#Row x Column to GCT converter
#Rob Borkowski, robert.borkowski@utsouthwestern.edu, 19 Oct 2011
#Take a row x column file (probes x samples) and convert to gct for genePattern
#syntax: perl rxc_to_gct.pl <filename>
#will output a .gct formatted file, "converted.gct".

{
    #open rxc file
    $file = "";
    open (DATA, $ARGV[0]) || die ;
    while (<DATA>) {
        $file .= $_;
    }
    close DATA;

    @probes = split/\n/, $file; #each line = array element
    
    #make the headers .gct-ready
    $pre_header = shift(@probes);

    @header = split/\t/, $pre_header;
    $head_len = @header;
    $num_samples = $head_len-1; #adjusts for the probe ID to get true # of samples
    unshift(@header,"NAME");
    $header[1] = "Description";
    
    print "$num_samples columns.\n";
    $num_probes = @probes;
    $num_probes = $num_probes-1;
    print "$num_probes rows.\n";
    
    foreach $record (@probes) {
      chomp($record);
        #print "$record\n";
        @values= split /\t/, $record;
        
        $n = shift(@values);
        push(@names, $n); #probe list is easy, just one column
        
        #variable number of columns, so need to use the num samples determined before to fill it up.
        push @rows, [@values];
    }
    
    
    #print out in .gct formatting with ID, #samples, #probes
    open (OUTFILE, ">$ARGV[1].gct");
    print OUTFILE "#1.2\n";
    print OUTFILE "$num_probes\t$num_samples\n";
    foreach $h (@header){ print OUTFILE "$h\t";}
    print OUTFILE "\n";
    
    for($x = 0; $x <= $num_probes-1; $x ++){
        print OUTFILE "$names[$x]\tNA\t"; 
        for($r = 0; $r <= $num_samples-1; $r ++){
            print OUTFILE "$rows[$x][$r]\t";
        }
        print OUTFILE "\n";
    }
    close OUTFILE;
    
    print "Done.\n";
}